//------------------------------------------------------------------
// original idea and first version using Ichimoku by sohocool
//------------------------------------------------------------------

//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  LawnGreen
#property indicator_color2  Red
//#property indicator_color3  OrangeRed
#property indicator_width1  3
#property indicator_width2  3
//#property indicator_width3  1

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    atrPeriod       = 48;
extern double atrMultiplier   = 1;
extern int    Kijun           = 24;
extern int    KijunShift      = 0;
extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;

//
//
//
//
//

double Trend[];
double Trend1[];
double TrendDa[];
double TrendDb[];
double kj[];
double Up[];
double Dn[];
double Direction[];

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
      SetIndexBuffer(0,Trend);
      SetIndexStyle(0,DRAW_HISTOGRAM);
       SetIndexBuffer(1,Trend1);
      SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,TrendDa);
      SetIndexBuffer(3,TrendDb);
      SetIndexBuffer(4,kj);
      SetIndexBuffer(5,Up);
      SetIndexBuffer(6,Dn);
      SetIndexBuffer(7,Direction);
      
      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
         SetIndexShift(3,KijunShift * timeFrame/Period()); 
         
     IndicatorShortName(timeFrameToString(timeFrame)+" Soho_MrTools_SuperTrend_Ichimoku"); 
return(0);
}

//
//
//
//
//

int deinit() {  return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { Trend[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame==Period())
   {
      if (Direction[limit]==-1) CleanPoint(limit,TrendDa,TrendDb);
      for(int i=limit; i>=0; i--)
      {
         double khi    = High[i];
         double klo    = Low[i];
         double kprice = 0;
         if  (i >= Bars - Kijun) continue;
         for (int k = 1; k < Kijun; k++)
         {
            kprice = High[i+k];
            if(khi < kprice)  khi  = kprice;
         
            kprice = Low[i+k];
            if(klo  > kprice) klo  = kprice;
         }
        
         if ((khi+klo) > 0.0) 
              kj[i] = (khi + klo)/2; 
         else kj[i] = 0;
         
         double atr    = iATR(NULL,0,atrPeriod,i);
         double cprice = Close[i];
         double mprice = kj[i];
                Up[i]  = mprice+atrMultiplier*atr;
                Dn[i]  = mprice-atrMultiplier*atr;
         
         //
         //
         //
         //
         //

         TrendDa[i] = EMPTY_VALUE;
         TrendDb[i] = EMPTY_VALUE;
        // Trend[i] = EMPTY_VALUE;
        // Trend1[i] = EMPTY_VALUE;
         Direction[i] = Direction[i+1];
            if (cprice > Up[i+1]) Direction[i] =  1;
            if (cprice < Dn[i+1]) Direction[i] = -1;
            if (Direction[i] > 0) { Dn[i] = MathMax(Dn[i],Dn[i+1]); Trend[i] = 1;Trend1[i] = 0; }
            else                  { Up[i] = MathMin(Up[i],Up[i+1]); Trend1[i] = 1;Trend[i] = 0; }
            if (Direction[i]==-1) PlotPoint(i,TrendDa,TrendDb,Trend);

      }
      manageAlerts();
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   if (Direction[limit]==-1) CleanPoint(limit,TrendDa,TrendDb);
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         Trend[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",atrPeriod,atrMultiplier,Kijun,KijunShift,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,0,y);
         Trend1[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",atrPeriod,atrMultiplier,Kijun,KijunShift,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,1,y);
         Direction[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",atrPeriod,atrMultiplier,Kijun,KijunShift,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,7,y);
         TrendDa[i]   = EMPTY_VALUE;
         TrendDb[i]   = EMPTY_VALUE;
       //  Trend[i] = EMPTY_VALUE;
       //  Trend1[i] = EMPTY_VALUE;
         if (Direction[i]==-1) PlotPoint(i,TrendDa,TrendDb,Trend);
   }
   return(0);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
      if (first[i+2] == EMPTY_VALUE) {
          first[i]    = from[i];
          first[i+1]  = from[i+1];
          second[i]   = EMPTY_VALUE;
         }
      else {
          second[i]   = from[i];
          second[i+1] = from[i+1];
          first[i]    = EMPTY_VALUE;
         }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar=0;
      if (Direction[whichBar] != Direction[whichBar+1])
      {
         if (Direction[whichBar] ==  1) doAlert("up"  );
         if (Direction[whichBar] == -1) doAlert("down");
      }
   }
}

//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message =  timeFrameToString(Period())+" "+Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" super trend ichimoku changed to "+doWhat;
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(Symbol()+" super trend ichimoku ",message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}


